
{$A+,B-,D+,E+,F-,I+,L+,N-,O-,R+,S+,V-}
{$M 16384,20000,655360}

PROGRAM CALLSORT;

(**********************************)
(*                                *)
(*           RAWAHO-SOFT          *)
(*  ============================  *)
(*                                *)
(* Version          : 1.00        *)
(* Projektstart     : 27.01.91    *)
(* Letzte Aenderung : 01.02.91    *)
(*   gemacht von    : "Eddy"      *)
(* Programmierer    : Walter Ralf *)
(*                    DG2MHF      *)
(* Stunden          : 8           *)
(*                                *)
(* Bitte schickt mir Aenderungs-  *)
(* (Verbesserungs-)vorschlaege    *)
(* oder Hinweise auf Fehler       *)
(* als MAIL an DG2MHF (auch       *)
(* verbales "Schulterklopfen"     *)
(* wird gerne entgegengenommen!)  *)
(*                                *)
(**********************************)

USES Crt;

CONST MaxCallLen  = 8;   (* Laenge des laengsten Calls *)

      Extend     = #000; (* Zeichen fuer erweiterten Tastaturcode *)
      BS         =   #8; (* BackSpace *)
      CR         =  #13; (* Return *)
      ESC        =  #27;
      F1         = #059; (* Funktionstasten *)
      CrsrHome   = #071;
      CrsrLeft   = #075;
      CrsrRight  = #077;
      CrsrEnd    = #079;
      DEL        = #083;

TYPE CharSet  = Set Of Char;
     DataPtr  = ^DataType;
     DataType = RECORD
                  Next   : DataPtr;
                  OffSet : Byte;
                  Inhalt : String;
                END; (* record *)
     SkipMode = (NoSkip,LineSkip,WordSkip);

CONST NumSet      : CharSet = ['0'..'9'];
      AlphaSet    : CharSet = ['a'..'z','A'..'Z'];
      JaNeinSet   : CharSet = ['J','j','N','n'];
      AlphaNumSet : CharSet = ['0'..'9','a'..'z','A'..'Z'];
      PathSet     : CharSet = ['0'..'9','a'..'z','A'..'Z',':','\','.'];
      SonderSet   : CharSet = ['!','@','#','&','%','$','-','/'];


VAR  OrgPtr     : DataPtr;   (* Erster (dummy-)Eintrag *)
     FirstPtr   : DataPtr;   (* Vorgaenger der Sortierliste *)
     LastPtr    : DataPtr;   (* Letztes Eingefuegtes Element *)
     SkipArt    : SkipMode;  (* UeberspringArt *)
     SuchWort   : String;    (*  *)
     SkipLine   : Integer;   (* Anzahl der zu ueberspringenden Zeilen *)
     StartZeile : Integer;   (* Zeilen, die uebersprungen werden sollen *)
     AktZeile   : Integer;   (* Aktuelle Quelldateizeilennummer *)
     QuellName  : String;    (*  *)
     ZielName   : String;    (*  *)
     QuellDatei : Text;      (*  *)
     ZielDatei  : Text;      (*  *)
     s          : String;    (* Verarbeitungs-String *)

(*########################################################################*)

FUNCTION Eingabe(default:String;zeichen:CharSet;laenge:Integer):String;
(**************************************************************************)
(* PARAMETER:                                                             *)
(*  default : Der Wert, der vorgegeben wird                               *)
(*  zeichen : Ein SET OF CHAR der erlaubten Zeichen                       *)
(*  laenge  : Maximale Laenge der Eingabe                                 *)
(**************************************************************************)
(* ERGEBNIS:                                                              *)
(*  Ein String, der nicht leer sein darf                                  *)
(**************************************************************************)
(* SPEZIFIKATION:                                                         *)
(*  Es wird die Eingabe eines Stringes unterstuetzt der nur aus den       *)
(*  erlaubten Zeichen bestehen darf.                                      *)
(*  Wird die ESC-Taste gedrueckt, so wird das Programm verlassen          *)
(**************************************************************************)
(* APPLIKATION:                                                           *)
(*                                                                        *)
(**************************************************************************)

 VAR posi,
     len  : Integer;
     xpos,
     ypos : Integer;
     s    : String;
     c    : Char;

(*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*)

  PROCEDURE Beep;
   BEGIN (* Beep *)
    Write(#7);
   END; (* Beep *)

(*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*)

 BEGIN (* Eingabe *)

  WHILE KeyPressed DO
    c:=ReadKey; (* TastaturPuffer leeren *)
  s:='';
  posi:=1;
  len:=0;
  WHILE (posi<=Length(default)) AND (len<laenge) DO
   BEGIN
    IF (default[posi] IN Zeichen) THEN
     BEGIN
      s:=s+default[posi];
      Inc(len);
     END; (* if *)
    Inc(posi);
   END; (* while *)
  posi:=len+1;
  xpos:=WhereX;
  IF xpos+laenge>=80 THEN
    laenge:=79-xpos;
  ypos:=WhereY;
  REPEAT
    GotoXY(xpos,ypos);
    ClrEol;
    Write(s);
    IF posi>laenge THEN
     BEGIN
      posi:=laenge;
      Beep;
     END; (* if *)
    GotoXY(xpos+posi-1,ypos);
    c:=ReadKey;
    CASE c OF
      BS     : BEGIN
                IF posi>1 THEN
                 BEGIN
                  s:=Copy(s,1,posi-2)+Copy(s,posi,255);
                  Dec(len);
                  Dec(Posi);
                 END; (* if *)
               END; (* case BS *)
      ESC    : BEGIN
                WriteLn;
                WriteLn('Programm abgebrochen!!!');
                Halt;
               END; (* case ESC *)
      Extend : BEGIN
                c:=ReadKey;
                CASE c OF
                  F1        : BEGIN
                              END; (* case F1 *)
                  CrsrHome  : BEGIN
                               posi:=1;
                              END; (* case CrsrHome *)
                  CrsrLeft  : BEGIN
                               IF posi>1 THEN
                                 Dec(posi);
                              END; (* case CrsrLeft *)
                  CrsrRight : BEGIN
                               IF posi<=len THEN
                                 Inc(posi);
                              END; (* case CrsrRight *)
                  CrsrEnd   : BEGIN
                               posi:=len+1;
                              END; (* case CrsrEnd *)
                  DEL       : BEGIN
                               s:=Copy(s,1,posi-1)+Copy(s,posi+1,255);
                               Dec(len);
                              END; (* case DEL *)
                  ELSE
                    Beep;
                 END; (* case *)
                c:=Extend;
               END; (* case Extend *)
      ELSE
        IF (c IN Zeichen) THEN
          IF posi=laenge THEN
           BEGIN
            s[laenge]:=c;
            s[0]:=Chr(laenge);
            Beep;
           END
          ELSE
            IF (len<=laenge) THEN
             BEGIN
              s:=Copy(s,1,posi-1)+c+Copy(s,posi,255);
              Inc(len);
              Inc(posi);
             END
            ELSE
              Beep;
     END; (* case *)
  UNTIL (c=CR) AND (s<>'');
  WriteLn;
  Eingabe:=s;

 END; (* Eingabe *)

(**************************************************************************)

PROCEDURE Upper(VAR c:Char);
 BEGIN
  c:=UpCase(c);
 END;

(**************************************************************************)

PROCEDURE HilfsText;
(**************************************************************************)
(* PARAMETER: keine                                                       *)
(**************************************************************************)
(* SPEZIFIKATION:                                                         *)
(*  Gibt die Syntax und eine Kurzbeschreibung aus und stoppt das Programm *)
(**************************************************************************)
(* APPLIKATION:                                                           *)
(*  Lediglich durch WriteLn ausgegebene Information                       *)
(**************************************************************************)

VAR antwort : String[1];

BEGIN (* HilfsText *)

 WriteLn;
 WriteLn('CALLSORT sortiert die Calls einer DigiMap-Datei!');
 WriteLn('Aufruf-Syntax:');
 WriteLn('  CALLSORT [<QuellDatei> [<ZielDatei>] [<StartZeile> | "<Suchwort>"]] | [ ? ]');
 WriteLn('    Eckige Klammern bedeuten, dass diese Paramer optional sind');
 WriteLn('    Groesser-/Kleinerzeichen-Texte steht anstelle des Parameters');
 WriteLn('    Senkrechter Strich bedeutet ein ENTWEDER-ODER');
 WriteLn;
 WriteLn('    <QuellDatei> : Name der zu bearbeitenden Datei');
 WriteLn('    <ZielDatei>  : Name der Datei, in die das Ergebnis gespeichert werden soll');
 WriteLn('                   (bei Fehlen wird wieder in die QuellDatei geschrieben)');
 WriteLn('    <StartZeile> : Anzahl der Zeilen, die uebersprungen werden sollen');
 WriteLn('                   bzw. Zeile AB NULL GEZAEHLT, ab der sortiert wird');
 WriteLn('                   (bei Fehlen wird alles Sortiert)');
 WriteLn('    "<Suchwort>" : Anstelle der Angabe der StartZeile kann auch ein Suchwort');
 WriteLn('                   (in Anfuehrungszeichen) stehen. In diesem Fall wird ab der');
 WriteLn('                   naechten Zeile sortiert, nach der das Suchwort zum ersten');
 WriteLn('                   mal gefunden worden ist');
 WriteLn;
 Write('Willst Du Beispiele (J/N) ? ');
 antwort:=Eingabe('N',JaNeinSet,2);
 IF (antwort<>'n') AND (antwort<>'N') THEN
  BEGIN
   WriteLn('  Beispiele:');
   WriteLn('    CALLSORT');
   WriteLn('      ohne Parameter startet das Programm im interaktiven Modus');
   WriteLn('    CALLSORT test');
   WriteLn('      sortiert die GANZE Datei "test"; das Ergebnis steht AUCH in "test"');
   WriteLn('    CALLSORT testeins testzwei');
   WriteLn('      sortiert die GANZE Datei "testeins" in "testzwei"');
   WriteLn('    CALLSORT test 123');
   WriteLn('      sortiert die Datei "test" ab Zeile 124 auf sich selbst');
   WriteLn('    CALLSORT test "link"');
   WriteLn('      sortiert die Datei "test" auf sich selbst, beginnen mit der');
   WriteLn('      Zeile, die auf die Zeile mit dem Wort "link" folgt');
   WriteLn('    CALLSORT testeins testzwei 123');
   WriteLn('      sortiert die Datei "testeins" in "testzwei" ab Zeile 124');
   WriteLn('    CALLSORT testeins testzwei "link"');
   WriteLn('      sortiert die Datei "testeins" auf "testzwei", beginnend mit');
   WriteLn('      der Folgezeile der Zeile, in der das Wort "link" steht');
   WriteLn('    CALLSORT ?');
   WriteLn('      Bringt diesen Hilfstext');
  END; (* if *)
 Halt;

END; (* HilfsText *)

(**************************************************************************)

PROCEDURE Sort(VAR s:String);
(**************************************************************************)
(* PARAMETER:                                                             *)
(*  s : Der String, in dem die in Klammern befindlichen Calls sortiert    *)
(*      werden sollen                                                     *)
(**************************************************************************)
(* SPEZIFIKATION:                                                         *)
(*  Sortiert die in runden Klammern befindlichen Calls und gibt eine      *)
(*  Fehlermeldung aus, wenn die Anzahl der Buchstaben und Ziffern laenger *)
(*  als MaxCallLen sind. Alle nicht-normalen Zeichen gelten als Trennung  *)
(**************************************************************************)
(* APPLIKATION:                                                           *)
(*  Ausfindigmachen der Calls, sortieren und wieder einfuegen             *)
(**************************************************************************)

 VAR CallList : ARRAY[1..50] OF String[MaxCallLen+5];
     hs       : String;  (* HilfsString *)
     CallAnz  : Integer; (* Anzahl der gefundenen Rufzeichen *)
     a,l      : Integer; (* Anfang und Laenge des Call-Einschubes *)

(*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*)

  PROCEDURE SplitCalls;

   VAR ts : String[30]; (* temporaerer CallString *)
       tl : Integer;    (* temporaere Laenge *)
       i  : Integer;

   BEGIN (* SplitCalls *)
    CallAnz:=0;
    WHILE hs<>'' DO
     BEGIN
      i:=1;
      ts:='';
      tl:=0;
      WHILE (i<=Length(hs)) AND (hs[i] IN AlphaNumSet+SonderSet) DO
       BEGIN
        ts:=ts+hs[i];
        IF hs[i] IN AlphaNumSet THEN
          Inc(tl);
        Inc(i);
       END; (* while *)
      IF tl=0 THEN
        (* nichts machen *)
      ELSE
        IF tl>MaxCallLen THEN
         BEGIN
          WriteLn('Zu langes Rufzeichen "',ts,'" in Zeile ',AktZeile,'!');
          Close(QuellDatei);
          Halt;
         END (* if *)
        ELSE
         BEGIN
          Inc(CallAnz);
          CallList[CallAnz]:=ts;
          hs:=Copy(hs,i,255);
         END; (* else/if *)
      hs:=Copy(hs,2,255);
     END; (* while *)
    FOR i:=1 TO CallAnz DO
      FOR tl:=1 TO Length(CallList[i]) DO
        Upper(CallList[i][tl]);

   END; (* SplitCalls *)

(*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*)

  PROCEDURE SortCalls;

   VAR SortOkay : Boolean;
       i        : Integer;

   BEGIN (* SortCalls *)

    (*** Stinknormaler Bubble-Sort ***)
    REPEAT
      SortOkay:=TRUE;
      FOR i:=2 TO CallAnz DO
        IF CallList[i-1]>CallList[i] THEN
         BEGIN
          hs:=CallList[i-1];
          CallList[i-1]:=CallList[i];
          CallList[i]:=hs;
          SortOkay:=FALSE;
         END; (* if/for *)
    UNTIL SortOkay;
    hs:='';
    FOR i:=1 TO CallAnz-1 DO
      hs:=hs+CallList[i]+',';
    IF CallAnz>0 THEN
      hs:=hs+CallList[CallAnz];

   END; (* SortCalls *)

(*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*)

 BEGIN (* Sort *)

  a:=Pos('(',s);
  IF a>0 THEN
   BEGIN
    hs:=Copy(s,a+1,255);
    l:=Pos(')',hs);
    IF l>0 THEN
     BEGIN
      hs:=Copy(hs,1,l-1);
      SplitCalls;
      SortCalls;
      s:=Copy(s,1,a)+hs+Copy(s,a+l,255);
     END (* then/if *)
    ELSE
     BEGIN
      Close(QuellDatei);
      WriteLn('Fehlende Klammer-Zu in Zeile ',AktZeile,'!');
      Halt;
     END; (* else/if *)
   END; (* if *)

 END; (* Sort *)

(**************************************************************************)

PROCEDURE Anfuegen(s:String);
(**************************************************************************)
(* PARAMETER:                                                             *)
(*  s : Der String, der ans Ende der Liste gesetzt werden soll            *)
(**************************************************************************)
(* SPEZIFIKATION:                                                         *)
(*  Diese Prozedur fuegt den String am Ende der Liste ein (mit Bestimmung *)
(*  des OffSet. Sie verwendet dafuer den Pointer LastPtr.                 *)
(*  Es muss Speicher auf dem Heap angefordert werden (nur soviel wie      *)
(*  unbedingt notwendig)                                                  *)
(**************************************************************************)
(* APPLIKATION:                                                           *)
(*                                                                        *)
(**************************************************************************)

 VAR i,len : Byte;
     Ptr   : DataPtr;

 BEGIN (* Anfuegen *)

  len:=Length(s);
  i:=1;
  WHILE (i<=len) AND NOT (s[i] IN AlphaNumSet) DO
    Inc(i);

  Ptr:=LastPtr;
  GetMem(LastPtr,4+1+1+len);
  Ptr^.Next:=LastPtr;
  WITH LastPtr^ DO
   BEGIN
    Next:=NIL;
    OffSet:=i;
    Inhalt:=s;
   END; (* with *)

 END; (* Anfuegen *)

(**************************************************************************)

PROCEDURE Einfuegen(s:String);
(**************************************************************************)
(* PARAMETER:                                                             *)
(*  s : Der String, der folgerichtig in die Liste eingefuegt werden soll  *)
(**************************************************************************)
(* SPEZIFIKATION:                                                         *)
(*  Der String soll alphabetisch richtig in die Liste eingefuegt werden.  *)
(*  Es stehen dazu zwei Pointer zur Verfuegung:                           *)
(*  der FirstPtr und der LastPtr;                                         *)
(*  Ausserdem muss auch noch der Offset des ersten Zeichens bestimmt      *)
(*  werden, das ein Buchstabe oder Ziffer ist                             *)
(*  Es muss Speicher auf dem Heap angefordert werden (nur soviel wie      *)
(*  unbedingt notwendig)                                                  *)
(**************************************************************************)
(* APPLIKATION:                                                           *)
(*                                                                        *)
(**************************************************************************)

 VAR i,j,len  : Byte;
     DatenPtr : DataPtr;
     Ptr,PtrN : DataPtr;
     hs       : String;

 BEGIN (* Einfuegen *)

  len:=Length(s);
  i:=1;
  WHILE (i<=len) AND NOT (s[i] IN AlphaNumSet) DO
    Inc(i);
  j:=i;
  WHILE (j<=len) AND (s[j] IN AlphaNumSet) DO
   BEGIN
    Upper(s[j]);
    Inc(j);
   END; (* while *)

  hs:=Copy(s,i,255);
  Ptr:=FirstPtr;
  PtrN:=Ptr^.Next;
  IF (PtrN=NIL) OR (Copy(LastPtr^.Inhalt,LastPtr^.OffSet,255)<=hs) THEN
    Anfuegen(s)
  ELSE
   BEGIN
    WHILE Copy(PtrN^.Inhalt,PtrN^.OffSet,255)<hs DO
     BEGIN
      Ptr:=PtrN;
      PtrN:=PtrN^.Next;
     END; (* while *)
    GetMem(DatenPtr,4+1+1+len);
    WITH DatenPtr^ DO
     BEGIN
      Next:=PtrN;
      OffSet:=i;
      Inhalt:=s;
     END; (* with *)
    Ptr^.Next:=DatenPtr;
   END; (* else/if *)

 END; (* Einfuegen *)

(**************************************************************************)

PROCEDURE ParameterAuswertung;
(**************************************************************************)
(* PARAMETER: keine                                                       *)
(**************************************************************************)
(* SPEZIFIKATION:                                                         *)
(*  Die Parameter werden auf ihre Richtigkeit hin ueberprueft (zum einen  *)
(*  Anzahl und Form, zum anderen ob die Quelldatei existiert) zugeordnet  *)
(* oder gegebenenfalls der Hilfstext ausgebenen                           *)
(*  Es wird SkipArt dementsprechend gesetzt und QuellDatei eroeffnet      *)
(**************************************************************************)
(* APPLIKATION:                                                           *)
(*                                                                        *)
(**************************************************************************)

 VAR Rest : Integer;

 BEGIN (* ParameterAuswertung *)

  QuellName:=ParamStr(1);
  IF QuellName[1]='?' THEN
    HilfsText;
  Assign(QuellDatei,QuellName);
{$i-}
  ReSet(QuellDatei);
  IF IOResult<>0 THEN
   BEGIN
    WriteLn('Datei "',QuellName,'" nicht ansprechbar!');
    Halt;
   END; (* if *)
{$i+}

  ZielName:=QuellName;

  CASE ParamCount OF
    1 : BEGIN
         SkipArt:=NoSkip;
        END; (* case 1 *)
    2 : BEGIN
         SuchWort:=ParamStr(2);
         Val(SuchWort,SkipLine,Rest);
         IF Rest=0 THEN
          BEGIN
           SkipArt:=LineSkip;
          END (* then/if *)
         ELSE
           IF (SuchWort[1]='"') AND (SuchWort[Length(SuchWort)]='"') THEN
            BEGIN
             SuchWort:=Copy(SuchWort,2,Length(SuchWort)-2);
             SkipArt:=WordSkip;
            END (* then/if *)
           ELSE
            BEGIN
             ZielName:=SuchWort;
             SkipArt:=NoSkip;
            END; (* else/if *)
        END; (* case 2 *)
    3 : BEGIN
         ZielName:=ParamStr(2);
         SuchWort:=ParamStr(3);
         Val(SuchWort,SkipLine,Rest);
         IF Rest=0 THEN
           SkipArt:=LineSkip
         ELSE
          BEGIN
           SkipArt:=WordSkip;
           IF (SuchWort[1]='"') AND (SuchWort[Length(SuchWort)]='"') THEN
             SuchWort:=Copy(SuchWort,2,Length(SuchWort)-2)
           ELSE
             HilfsText;
          END; (* else/if *)
        END; (* case 3 *)
    ELSE
      HilfsText;
   END; (* case *)

 END; (* ParameterAuswertung *)

(**************************************************************************)

PROCEDURE Interaktiv;
(**************************************************************************)
(* PARAMETER: keine                                                       *)
(**************************************************************************)
(* SPEZIFIKATION:                                                         *)
(*  Es werden interaktiv die Parameter abgefragt. Bei der Eingabe des     *)
(*  QuellDateiNames wird nur eine gueltige Datei anerkannt. Die ZielDatei *)
(*  wird mit der QuellDatei gleichgesetzt und eine Aenderung abgefragt.   *)
(*  Bei der Abfrage nach StartZeile/SuchWort wird eine 0 eingetragen      *)
(*  und keine Leerzeichen akzeptiert                                      *)
(*  Es wird SkipArt dementsprechend gesetzt und QuellDatei eroeffnet      *)
(**************************************************************************)
(* APPLIKATION:                                                           *)
(*                                                                        *)
(**************************************************************************)

 VAR Rest : Integer;

 LABEL Label1;

 BEGIN (* Interaktiv *)

  ClrScr;
  WriteLn('CALLSORT written by EDDY (DG2MHF)');
{$i-}
  REPEAT
    GotoXY(1,3);
    Write('QuellDateiName      : ');
    QuellName:=Eingabe('',PathSet,40);
    Assign(QuellDatei,QuellName);
    ReSet(QuellDatei);
  UNTIL IOResult=0;
{$i+}
  Write('ZielDateiName       : ');
  ZielName:=Eingabe(QuellName,PathSet,40);
  Write('Startzeile/Suchwort : ');
  SuchWort:=Eingabe('0',['!'..''],40);
  Val(SuchWort,SkipLine,Rest);
  IF Rest=0 THEN
    SkipArt:=LineSkip
  ELSE
   BEGIN
    IF (SuchWort[1]='"') AND (SuchWort[Length(SuchWort)]='"') THEN
      SuchWort:=Copy(SuchWort,2,Length(SuchWort)-2);
    SkipArt:=WordSkip;
   END; (* else/if *)

 END; (* Interaktiv *)

(**************************************************************************)

PROCEDURE Init;
(**************************************************************************)
(* PARAMETER: keine                                                       *)
(**************************************************************************)
(* SPEZIFIKATION:                                                         *)
(*  Erstes (dummy-)Element auf Heap setzen und Zeiger dementsprechend     *)
(*  setzen (OrgPtr,FirstPtr und LastPtr)                                  *)
(*  ZeilenNummer auf Null setzen                                          *)
(*                                                                        *)
(*                                                                        *)
(*                                                                        *)
(**************************************************************************)
(* APPLIKATION:                                                           *)
(*                                                                        *)
(**************************************************************************)

 BEGIN (* Init *)

  GetMem(FirstPtr,4);
  FirstPtr^.Next:=NIL;
  LastPtr:=FirstPtr;
  OrgPtr:=FirstPtr;
  AktZeile:=0;

 END; (* Init *)

(**************************************************************************)

PROCEDURE Abspeichern;
(**************************************************************************)
(* PARAMETER: keine                                                       *)
(**************************************************************************)
(* SPEZIFIKATION:                                                         *)
(*  Speichert die Liste in die ZielDatei ab                               *)
(**************************************************************************)
(* APPLIKATION:                                                           *)
(*                                                                        *)
(**************************************************************************)

 VAR Ptr : DataPtr;

 LABEL Label1;

 BEGIN (* Abspeichern *)

{$i-}
Label1:
  Assign(ZielDatei,ZielName);
  ReWrite(ZielDatei);
  IF IOResult<>0 THEN
   BEGIN
    WriteLn('Kann ZielDatei "',ZielName,'" nicht oeffnen!');
    Write('Bitte neuen Namen eingeben oder ESC druecken : ');
    ZielName:=Eingabe(ZielName,PathSet,40);
    GOTO Label1;
   END; (* if *)
{$i+}
  Ptr:=OrgPtr^.Next;
  WHILE Ptr<>NIL DO
   BEGIN
    WriteLn(ZielDatei,Ptr^.Inhalt);
    Ptr:=Ptr^.Next;
   END; (* while *)
  Close(ZielDatei);

 END; (* Abspeichern *)

(*########################################################################*)

BEGIN (* CALLSORT *)

  IF ParamCount=0 THEN
    Interaktiv
  ELSE
   BEGIN
    WriteLn('CALLSORT written by EDDY (DG2MHF)');
    ParameterAuswertung;
   END; (* else/if *)

  Init;

  CASE SkipArt OF
    LineSkip : BEGIN
                WHILE (AktZeile<SkipLine) AND NOT Eof(QuellDatei) DO
                 BEGIN
                  ReadLn(QuellDatei,s);
                  Anfuegen(s);
                  Inc(AktZeile);
                  write(AktZeile,#13);
                 END; (* while *)
                IF NOT Eof(QuellDatei) THEN
                  SkipArt:=NoSkip;
               END; (* case LineSkip *)
    WordSkip : BEGIN
                WHILE (SkipArt=WordSkip) AND NOT Eof(QuellDatei) DO
                 BEGIN
                  ReadLn(QuellDatei,s);
                  Anfuegen(s);
                  IF Pos(SuchWort,s)>0 THEN
                    SkipArt:=NoSkip;
                  Inc(AktZeile);
                  write(AktZeile,#13);
                 END; (* while *)
               END; (* case WordSkip *)
   END; (* case *)

  FirstPtr:=LastPtr;

  IF SkipArt<>NoSkip THEN
   BEGIN
    Close(QuellDatei);
    IF ZielName<>QuellName THEN
     BEGIN
      WriteLn('Keine Veraenderung vorgenommen!');
      Write('Datei trotzdem abspeichern? ');
      s:=Eingabe('N',JaNeinSet,1);
      IF (s<>'n') AND (s<>'N') THEN
        Abspeichern;
     END; (* if *)
    Halt;
   END; (* if *)

  WHILE NOT Eof(QuellDatei) DO
   BEGIN
    ReadLn(QuellDatei,s);
    Inc(AktZeile);
    write(AktZeile,#13);
    Sort(s);
    Einfuegen(s);
   END; (* while *)
  Close(QuellDatei);

  Abspeichern;

END. (* CALLSORT *)

(*########################################################################*)


