
(*
   Aus gegebenem Anla:
   Ein Programm zum berprfen von DIGIMAP 2-Datendateien.

   Aufruf:  CHECKDMD [<dateiname>]

   Ohne <dateiname> wird DIGIMAPD.TXT geprft. Gefundene
   Fehler werden in einer Datei mit der Extension .ERR
   protokolliert, und zwar zunchst fast nur Syntaxfehler
   (d.h. formale Fehler im Aufbau der Zeilen).
   Erst wenn keine Syntaxfehler mehr vorhanden sind,
   werden die Link-Listen auf Konsistenz geprft.

   Da bei der Syntax der Zeilen eine genaue Fehlerortung
   schwierig ist, sind die Fehlermeldungen nur als grobe
   Hinweise zu verstehen. Irgendetwas ist aber sicherlich
   faul, wenn ein Fehler gemeldet wird!

                       -- * --

   Written in glorious TURBO PASCAL Version 5.5.

   Zugegeben, am Programm ist bestimmt einiges
   verbesserungswrdig, aber es erfllt seinen Zweck.
   Immerhin sortiert es die Records schon alphabetisch.
   (Der nchste Schritt wre wohl, da das Programm
    mindestens Fehler in der Linkliste korrigiert
    und die korrigierten Daten wieder rausschreibt.
    Aber dazu fehlte mir die Lust und die Zeit...)

   Keep Hacking!         73 de Martin, DK9AH @ DK0MAV
*)

{$A+,B-,D+,E+,F-,I+,L+,N-,O-,R+,S+,V+,M 16384,0,655360}

const
  callength   = 8; { Eigentlich ja 6, aber da irgendjemand auf
                     die Idee kam, den SSID anzuhngen...      }

  DefFileName = 'DIGIMAPD';
  DefDatExt   = '.TXT';
  DefErrExt   = '.ERR';


type
  errTyp  = (E_NOCOMMA, E_NOCALL , E_LOCLEN , E_TYPVAL ,
             E_TYPERR , E_FREQVAL, E_RADVAL , E_NOLBRA ,
             E_NORBRA , E_NOLCALL, E_COMLEN , E_NOLINK ,
             E_LINKTYP, E_NOENTRY, E_DOUBLE
            );

  recPtr  = ^recTyp;
  linkPtr = ^linkTyp;

  linkTyp = record
              recP : recPtr;
              lTyp : char;
              next : linkPtr
            end;

  recTyp  = record
              lNum    : integer;
              call    : string[callength];
              loc     : string[6];
              freq    : longint;
              typ     : byte;
              rad     : word;
              links   : linkPtr;
              comment : string[70];
              next    : recPtr
            end;


const
  nulrec  : recTyp = (lNum    :   0;
                      call    :  '';
                      loc     :  '';
                      freq    :   0;
                      typ     :   0;
                      rad     :   0;
                      links   : NIL;
                      comment :  '';
                      next    : NIL);

  nullink : linkTyp = (recP : NIL;
                       lTyp : ' ';
                       next : NIL);


var
  DatFileName,
  ErrFileName  : string[12];
  dat,
  err          : text;
  datOpen      : boolean;
  lineNum,
  recNum,
  errcnt       : integer;
  line         : string;
  hierHeap     : ^integer;
  recRoot      : recPtr;
  lastcall     : string[callength];

procedure StopIt;

begin
  if datOpen then close(dat);
  if hierHeap <> NIL then release(hierHeap);
  halt
end {StopIt};


procedure Fehler ( code : errTyp; s1,s2 : string );

begin
  inc(errcnt);
  write(err,lineNum:4,': ');
  case code of
    E_NOCOMMA: write(err,''','' missing');
    E_NOCALL : write(err,'Invalid callsign ',s1);
    E_LOCLEN : write(err,'Locator too long');
    E_TYPVAL : write(err,'Type value error');
    E_TYPERR : write(err,'Wrong type value ',s1);
    E_FREQVAL: write(err,'Frequency value error');
    E_RADVAL : write(err,'Radius value error');
    E_NOLBRA : write(err,'''('' missing');
    E_NORBRA : write(err,''')'' missing');
    E_NOLCALL: write(err,'Invalid Linklist callsign ',s1);
    E_COMLEN : write(err,'Comment too long');
    E_NOLINK : write(err,s1,': not in ',s2,'''s linklist');
    E_LINKTYP: write(err,s1,': wrong linktyp to ',s2);
    E_NOENTRY: write(err,s1,': no entry');
    E_DOUBLE : write(err,s1,': double entry');
    else       write(err,'Unknown error')
  end;
  writeln(err)
end {Fehler};


procedure trim ( var s : string );

var
  l : integer;

begin
  while (s > '') and (s[1] = ' ') do
    delete(s,1,1);
  l := length(s);
  while (l > 0) and (s[l] = ' ') do begin
    delete(s,l,1);
    dec(l)
  end
end {trim};


procedure toUpper ( var s : string );

var
  i : integer;

begin
  for i := 1 to length(s) do
    s[i] := UpCase(s[i])
end {toUpper};


procedure getFileName;

var
  fnm,
  ext : string;
  p   : integer;

begin
  if ParamCount = 0 then begin
    fnm := DefFileName;
    ext := DefDatExt
  end
  else begin
    line := ParamStr(1);
    p := pos('.',line);
    if p = 0 then begin
      fnm := copy(line,1,8);
      ext := ''
    end
    else begin
      ext := copy(line,p,4);
      if p > 9 then p := 9;
      fnm := copy(line,1,pred(p))
    end;
    toUpper(fnm);
    toUpper(Ext);
   end;
   DatFileName := fnm+ext;
   ErrFileName := fnm+DefErrExt
end {getFileName};


procedure CheckLinks;

var
  rec   : recPtr;
  link,
  link1 : linkPtr;

begin
  rec := recRoot^.next;
  while rec <> NIL do begin
    lineNum := rec^.lNum;
    link := rec^.links;
    if lineNum = 0 then
      Fehler(E_NOENTRY,rec^.call,'')
    else
      while link <> NIL do begin
        if link^.recP^.lNum <> 0 then begin
          link1 := link^.recP^.links;
          while (link1 <> NIL) and (link1^.recP <> rec) do
            link1 := link1^.next;
          if link1^.recP <> rec then
            Fehler(E_NOLINK,rec^.call,link^.recP^.call)
          else
            if link^.lTyp <> link1^.lTyp then
              Fehler(E_LINKTYP,rec^.call,link^.recP^.call)
        end;
        link := link^.next
      end;
    rec := rec^.next
  end
end {CheckLinks};


function invalidCall ( s : string ) : boolean;

var
  i,
  l      : integer;
  isCall : boolean;

begin
  isCall := true;
  i := 1;
  l := length(s);
  while (i <= l) and isCall do begin
    { nur provisorisch; ausbaufhig! }
    isCall := s[i] in ['0'..'9','A'..'Z'];
    inc(i)
  end;
  invalidCall := not isCall
end;


function findCall ( call : string ) : recPtr;

var
  rPre,
  rAct  : recPtr;

begin
  call := copy(call,1,callength);
  rPre := recRoot;
  rAct := rPre^.next;
  while (rAct <> NIL) and (rAct^.call <= call) do begin
    rPre := rAct;
    rAct := rPre^.next
  end;
  if (call = rPre^.call) then
    findCall := rPre
  else begin
    new(rAct);
    rAct^ := nulrec;
    rAct^.call := call;
    rAct^.next := rPre^.next;
    rPre^.next := rAct;
    findCall := rAct
  end
end {FindCall};


procedure Decode ( line : string );

const
 SpecialLinks : set of char = ['!','@','#','$','%','&'];

var
  line1,
  line2   : string;
  rec     : recPtr;
  link,
  link1   : linkPtr;
  p,
  valCode : integer;
  value   : real;

  procedure MoveLine;
  begin
    line1 := copy(line,1,pred(p));
    trim(line1);
    delete(line,1,p)
  end;

begin
  p := pos(',',line);
  if p < 2 then begin
    Fehler(E_NOCOMMA,'','');
    exit
  end;
  MoveLine;
  toUpper(line1);
  if invalidCall(line1) then begin
    Fehler(E_NOCALL,line1,'');
    exit
  end;
  rec := findCall(line1);
  if rec^.call=lastcall then Fehler(E_DOUBLE,line1,'');
  lastcall:=rec^.call;
  rec^.lNum := lineNum;

  p := pos(',',line);
  if p < 2 then begin
    Fehler(E_NOCOMMA,'','');
    exit
  end;
  MoveLine;
  p := length(line1);
  if {(p < 5) or} (p > 6) then begin
    Fehler(E_LOCLEN,'','');
    exit
  end;
  rec^.loc := line1;

  p := pos(',',line);
  if p < 2 then begin
    Fehler(E_NOCOMMA,'','');
    exit
  end;
  MoveLine;
  val(line1,value,valCode);
  if valCode <> 0 then begin
    Fehler(E_TYPVAL,'','');
    exit
  end;
  if (value < 1) or (value > 3) then begin
    Fehler(E_TYPERR,line1,'');
    exit
  end;
  rec^.typ := trunc(value);

  p := pos(',',line);
  if p < 2 then begin
    Fehler(E_NOCOMMA,'','');
    exit
  end;
  MoveLine;
  if line1 = '' then
    rec^.freq := 0
  else begin
    val(line1,value,valCode);
    if valCode <> 0 then begin
      Fehler(E_FREQVAL,'','');
      exit
    end;
    rec^.freq := trunc(value*1000)
  end;

  p := pos(',',line);
  if p < 2 then begin
    Fehler(E_NOCOMMA,'','');
    exit
  end;
  MoveLine;
  if line1 = '' then
    rec^.rad := 0
  else begin
    val(line1,value,valCode);
    if valCode <> 0 then begin
      Fehler(E_RADVAL,'','');
      exit
    end;
    rec^.rad := trunc(value)
  end;

  trim(line);
  if line[1] <> '(' then begin
    Fehler(E_NOLBRA,'','');
    exit
  end;
  delete(line,1,1);
  p := pos(')',line);
  if p = 0 then begin
    Fehler(E_NORBRA,'','');
    exit
  end;
  MoveLine;
  line1 := line1+',';
  p := pos(',',line1);
  while p > 1 do begin
    new(link);
    link^ := nullink;
    if rec^.links = NIL then
      rec^.links := link
    else
      link1^.next := link;
    link1 := link;

    line2 := copy(line1,1,pred(p));
    trim(line2);
    toUpper(line2);
    delete(line1,1,p);
    p := length(line2);
    link^.lTyp := line2[p];
    if link^.lTyp in SpecialLinks then
      delete(line2,p,1)
    else
      link^.lTyp:=' ';
    if invalidCall(line2) then begin
      Fehler(E_NOLCALL,line2,'');
      exit
    end;
    link^.recP := findCall(line2);

    p := pos(',',line1)
  end;

  p := pos(',',line);
  if p = 0 then begin
    Fehler(E_NOCOMMA,'','');
    exit
  end;
  delete(line,1,p);
  trim(line);
  if length(line) > 70 then begin
    Fehler(E_COMLEN,'','');
    exit
  end;
  rec^.comment := line

end {Decode};


begin {main}
  datOpen := false;
  hierHeap := NIL;

  getFileName;

  assign(dat,DatFileName);
  {$I-}
  reset(dat);
  {$I+}
  if IOResult <> 0 then begin
    writeln('File ',DatFileName,' not found');
    StopIt
  end;
  datOpen := true;

  errcnt := 0;
  assign(err,ErrFileName);
  rewrite(err);
  writeln(err,'General error list for ',DatFileName);
  writeln(err);

  mark(hierHeap);
  new(recRoot);
  recRoot^ := nulrec;
  recRoot^.call := '      ';

  lineNum := 0;
  recNum := 0;
  writeln('Processing ',DatFileName);
  while not eof(dat) do begin
    inc(lineNum);
    readln(dat,line);
    write(lineNum,#13);
    trim(line);
{    if line[1] <> '#' then begin}
     if line[1]='#' then delete (line,1,1);
      inc(recNum);
      Decode(line)
{    end}
  end;
  close(dat);
  close(err);
  writeln(recNum,' records in ',lineNum,' lines');

  if errcnt > 0 then
    writeln(errcnt,' errors found')
  else begin
    rewrite(err);
    writeln(err,'Linklist error list for ',DatFileName);
    writeln(err);
    CheckLinks;
    close(err);
    if errcnt > 0 then
      writeln(errcnt,' linklist errors found')
  end;

  if errcnt > 0 then
    writeln('  (See ',ErrFileName,' for Details)')
  else
    writeln('No errors found');

  release(hierHeap)
end.
